diff --git a/sys/contrib/dev/acpica/source/components/utilities/utdecode.c b/sys/contrib/dev/acpica/source/components/utilities/utdecode.c
index e470dfc416..3daff815ff 100644
--- a/sys/contrib/dev/acpica/source/components/utilities/utdecode.c
+++ b/sys/contrib/dev/acpica/source/components/utilities/utdecode.c
@@ -214,17 +214,17 @@ const UINT8                     AcpiGbl_NsProperties[ACPI_NUM_NS_TYPES] =
 
 const char        *AcpiGbl_RegionTypes[ACPI_NUM_PREDEFINED_REGIONS] =
 {
-    "SystemMemory",     /* 0x00 */
-    "SystemIO",         /* 0x01 */
-    "PCI_Config",       /* 0x02 */
-    "EmbeddedControl",  /* 0x03 */
-    "SMBus",            /* 0x04 */
-    "SystemCMOS",       /* 0x05 */
-    "PCIBARTarget",     /* 0x06 */
-    "IPMI",             /* 0x07 */
-    "GeneralPurposeIo", /* 0x08 */
-    "GenericSerialBus", /* 0x09 */
-    "PCC"               /* 0x0A */
+    "SystemMemory",      /* 0x00 */
+    "SystemIO",          /* 0x01 */
+    "PCI_Config",        /* 0x02 */
+    "EmbeddedControl",   /* 0x03 */
+    "SMBus",             /* 0x04 */
+    "SystemCMOS",        /* 0x05 */
+    "PCIBARTarget",      /* 0x06 */
+    "IPMI",              /* 0x07 */
+    "GeneralPurposeIo",  /* 0x08 */
+    "GenericSerialBus",  /* 0x09 */
+    "PlatformCommChannel"/* 0x0A */
 };
 
 
@@ -416,7 +416,7 @@ AcpiUtGetNodeName (
     ACPI_NAMESPACE_NODE     *Node = (ACPI_NAMESPACE_NODE *) Object;
 
 
-    /* Must return a string of exactly 4 characters == ACPI_NAME_SIZE */
+    /* Must return a string of exactly 4 characters == ACPI_NAMESEG_SIZE */
 
     if (!Object)
     {
@@ -632,7 +632,7 @@ static const char           *AcpiGbl_GenericNotify[ACPI_GENERIC_NOTIFY_MAX + 1]
     /* 0B */ "System Locality Update",
     /* 0C */ "Reserved (was previously Shutdown Request)",  /* Reserved in ACPI 6.0 */
     /* 0D */ "System Resource Affinity Update",
-    /* 0E */ "Heterogeneous Memory Attributes Update"       /* ACPI 6.2 */
+    /* 0E */ "Heterogeneous Memory Attributes Update",      /* ACPI 6.2 */
     /* 0F */ "Error Disconnect Recover"                     /* ACPI 6.3 */
 };
 
diff --git a/sys/contrib/dev/acpica/source/components/utilities/utmisc.c b/sys/contrib/dev/acpica/source/components/utilities/utmisc.c
index acc048d665..466e3fa26c 100644
--- a/sys/contrib/dev/acpica/source/components/utilities/utmisc.c
+++ b/sys/contrib/dev/acpica/source/components/utilities/utmisc.c
@@ -214,10 +214,10 @@ AcpiUtIsAmlTable (
 
     /* These are the only tables that contain executable AML */
 
-    if (ACPI_COMPARE_NAME (Table->Signature, ACPI_SIG_DSDT) ||
-        ACPI_COMPARE_NAME (Table->Signature, ACPI_SIG_PSDT) ||
-        ACPI_COMPARE_NAME (Table->Signature, ACPI_SIG_SSDT) ||
-        ACPI_COMPARE_NAME (Table->Signature, ACPI_SIG_OSDT) ||
+    if (ACPI_COMPARE_NAMESEG (Table->Signature, ACPI_SIG_DSDT) ||
+        ACPI_COMPARE_NAMESEG (Table->Signature, ACPI_SIG_PSDT) ||
+        ACPI_COMPARE_NAMESEG (Table->Signature, ACPI_SIG_SSDT) ||
+        ACPI_COMPARE_NAMESEG (Table->Signature, ACPI_SIG_OSDT) ||
         ACPI_IS_OEM_SIG (Table->Signature))
     {
         return (TRUE);
diff --git a/sys/contrib/dev/acpica/source/components/utilities/utpredef.c b/sys/contrib/dev/acpica/source/components/utilities/utpredef.c
index e1cdd704e6..8d9c5b0b2f 100644
--- a/sys/contrib/dev/acpica/source/components/utilities/utpredef.c
+++ b/sys/contrib/dev/acpica/source/components/utilities/utpredef.c
@@ -237,7 +237,7 @@ AcpiUtMatchPredefinedMethod (
     ThisName = AcpiGbl_PredefinedMethods;
     while (ThisName->Info.Name[0])
     {
-        if (ACPI_COMPARE_NAME (Name, ThisName->Info.Name))
+        if (ACPI_COMPARE_NAMESEG (Name, ThisName->Info.Name))
         {
             return (ThisName);
         }
@@ -374,7 +374,7 @@ AcpiUtMatchResourceName (
     ThisName = AcpiGbl_ResourceNames;
     while (ThisName->Info.Name[0])
     {
-        if (ACPI_COMPARE_NAME (Name, ThisName->Info.Name))
+        if (ACPI_COMPARE_NAMESEG (Name, ThisName->Info.Name))
         {
             return (ThisName);
         }
diff --git a/sys/contrib/dev/acpica/source/components/utilities/utstring.c b/sys/contrib/dev/acpica/source/components/utilities/utstring.c
index 893a957451..f0ee49a0ec 100644
--- a/sys/contrib/dev/acpica/source/components/utilities/utstring.c
+++ b/sys/contrib/dev/acpica/source/components/utilities/utstring.c
@@ -303,16 +303,16 @@ AcpiUtRepairName (
      * Special case for the root node. This can happen if we get an
      * error during the execution of module-level code.
      */
-    if (ACPI_COMPARE_NAME (Name, ACPI_ROOT_PATHNAME))
+    if (ACPI_COMPARE_NAMESEG (Name, ACPI_ROOT_PATHNAME))
     {
         return;
     }
 
-    ACPI_MOVE_NAME (&OriginalName, Name);
+    ACPI_COPY_NAMESEG (&OriginalName, Name);
 
     /* Check each character in the name */
 
-    for (i = 0; i < ACPI_NAME_SIZE; i++)
+    for (i = 0; i < ACPI_NAMESEG_SIZE; i++)
     {
         if (AcpiUtValidNameChar (Name[i], i))
         {
diff --git a/sys/contrib/dev/acpica/source/include/aclocal.h b/sys/contrib/dev/acpica/source/include/aclocal.h
index 6a2d37c386..b8d274e1bd 100644
--- a/sys/contrib/dev/acpica/source/include/aclocal.h
+++ b/sys/contrib/dev/acpica/source/include/aclocal.h
@@ -480,7 +480,7 @@ ACPI_STATUS (*ACPI_INTERNAL_METHOD) (
  */
 typedef struct acpi_name_info
 {
-    char                        Name[ACPI_NAME_SIZE];
+    char                        Name[ACPI_NAMESEG_SIZE];
     UINT16                      ArgumentList;
     UINT8                       ExpectedBtypes;
 
@@ -568,7 +568,7 @@ typedef ACPI_STATUS (*ACPI_OBJECT_CONVERTER) (
 
 typedef struct acpi_simple_repair_info
 {
-    char                        Name[ACPI_NAME_SIZE];
+    char                        Name[ACPI_NAMESEG_SIZE];
     UINT32                      UnexpectedBtypes;
     UINT32                      PackageIndex;
     ACPI_OBJECT_CONVERTER       ObjectConverter;
diff --git a/sys/contrib/dev/acpica/source/include/acpixf.h b/sys/contrib/dev/acpica/source/include/acpixf.h
index ad653f0ef2..d3e4e7b547 100644
--- a/sys/contrib/dev/acpica/source/include/acpixf.h
+++ b/sys/contrib/dev/acpica/source/include/acpixf.h
@@ -154,7 +154,7 @@
 
 /* Current ACPICA subsystem version in YYYYMMDD format */
 
-#define ACPI_CA_VERSION                 0x20190215
+#define ACPI_CA_VERSION                 0x20190329
 
 #include "acconfig.h"
 #include "actypes.h"
diff --git a/sys/contrib/dev/acpica/source/include/actbl.h b/sys/contrib/dev/acpica/source/include/actbl.h
index 97134e5e76..d6b9e8ff21 100644
--- a/sys/contrib/dev/acpica/source/include/actbl.h
+++ b/sys/contrib/dev/acpica/source/include/actbl.h
@@ -213,14 +213,14 @@
 
 typedef struct acpi_table_header
 {
-    char                    Signature[ACPI_NAME_SIZE];          /* ASCII table signature */
+    char                    Signature[ACPI_NAMESEG_SIZE];       /* ASCII table signature */
     UINT32                  Length;                             /* Length of table in bytes, including this header */
     UINT8                   Revision;                           /* ACPI Specification minor version number */
     UINT8                   Checksum;                           /* To make sum of entire table == 0 */
     char                    OemId[ACPI_OEM_ID_SIZE];            /* ASCII OEM identification */
     char                    OemTableId[ACPI_OEM_TABLE_ID_SIZE]; /* ASCII OEM table identification */
     UINT32                  OemRevision;                        /* OEM revision number */
-    char                    AslCompilerId[ACPI_NAME_SIZE];      /* ASCII ASL compiler vendor ID */
+    char                    AslCompilerId[ACPI_NAMESEG_SIZE];   /* ASCII ASL compiler vendor ID */
     UINT32                  AslCompilerRevision;                /* ASL compiler version */
 
 } ACPI_TABLE_HEADER;
diff --git a/sys/contrib/dev/acpica/source/include/actypes.h b/sys/contrib/dev/acpica/source/include/actypes.h
index 2a65ee8f57..e7a2d57804 100644
--- a/sys/contrib/dev/acpica/source/include/actypes.h
+++ b/sys/contrib/dev/acpica/source/include/actypes.h
@@ -520,7 +520,7 @@ typedef UINT64                          ACPI_PHYSICAL_ADDRESS;
 
 /* Names within the namespace are 4 bytes long */
 
-#define ACPI_NAME_SIZE                  4
+#define ACPI_NAMESEG_SIZE               4           /* Fixed by ACPI spec */
 #define ACPI_PATH_SEGMENT_LENGTH        5           /* 4 chars for name + 1 char for separator */
 #define ACPI_PATH_SEPARATOR             '.'
 
@@ -666,11 +666,11 @@ typedef UINT64                          ACPI_INTEGER;
 /* Optimizations for 4-character (32-bit) ACPI_NAME manipulation */
 
 #ifndef ACPI_MISALIGNMENT_NOT_SUPPORTED
-#define ACPI_COMPARE_NAME(a,b)          (*ACPI_CAST_PTR (UINT32, (a)) == *ACPI_CAST_PTR (UINT32, (b)))
-#define ACPI_MOVE_NAME(dest,src)        (*ACPI_CAST_PTR (UINT32, (dest)) = *ACPI_CAST_PTR (UINT32, (src)))
+#define ACPI_COMPARE_NAMESEG(a,b)       (*ACPI_CAST_PTR (UINT32, (a)) == *ACPI_CAST_PTR (UINT32, (b)))
+#define ACPI_COPY_NAMESEG(dest,src)     (*ACPI_CAST_PTR (UINT32, (dest)) = *ACPI_CAST_PTR (UINT32, (src)))
 #else
-#define ACPI_COMPARE_NAME(a,b)          (!strncmp (ACPI_CAST_PTR (char, (a)), ACPI_CAST_PTR (char, (b)), ACPI_NAME_SIZE))
-#define ACPI_MOVE_NAME(dest,src)        (strncpy (ACPI_CAST_PTR (char, (dest)), ACPI_CAST_PTR (char, (src)), ACPI_NAME_SIZE))
+#define ACPI_COMPARE_NAMESEG(a,b)       (!strncmp (ACPI_CAST_PTR (char, (a)), ACPI_CAST_PTR (char, (b)), ACPI_NAMESEG_SIZE))
+#define ACPI_COPY_NAMESEG(dest,src)     (strncpy (ACPI_CAST_PTR (char, (dest)), ACPI_CAST_PTR (char, (src)), ACPI_NAMESEG_SIZE))
 #endif
 
 /* Support for the special RSDP signature (8 characters) */
@@ -680,7 +680,7 @@ typedef UINT64                          ACPI_INTEGER;
 
 /* Support for OEMx signature (x can be any character) */
 #define ACPI_IS_OEM_SIG(a)        (!strncmp (ACPI_CAST_PTR (char, (a)), ACPI_OEM_NAME, 3) &&\
-                                      strnlen (a, ACPI_NAME_SIZE) == ACPI_NAME_SIZE)
+                                      strnlen (a, ACPI_NAMESEG_SIZE) == ACPI_NAMESEG_SIZE)
 
 /*
  * Algorithm to obtain access bit width.
diff --git a/sys/contrib/dev/acpica/source/include/platform/aclinux.h b/sys/contrib/dev/acpica/source/include/platform/aclinux.h
index 990d17c7a7..f6522e3262 100644
--- a/sys/contrib/dev/acpica/source/include/platform/aclinux.h
+++ b/sys/contrib/dev/acpica/source/include/platform/aclinux.h
@@ -221,6 +221,11 @@
 #define ACPI_NO_ERROR_MESSAGES
 #undef ACPI_DEBUG_OUTPUT
 
+/* Use a specific bugging default separate from ACPICA */
+
+#undef ACPI_DEBUG_DEFAULT
+#define ACPI_DEBUG_DEFAULT          (ACPI_LV_INFO | ACPI_LV_REPAIR)
+
 /* External interface for __KERNEL__, stub is needed */
 
 #define ACPI_EXTERNAL_RETURN_STATUS(Prototype) \
diff --git a/sys/contrib/dev/acpica/source/os_specific/service_layers/osbsdtbl.c b/sys/contrib/dev/acpica/source/os_specific/service_layers/osbsdtbl.c
index 0f112781e0..0e00621624 100644
--- a/sys/contrib/dev/acpica/source/os_specific/service_layers/osbsdtbl.c
+++ b/sys/contrib/dev/acpica/source/os_specific/service_layers/osbsdtbl.c
@@ -319,8 +319,8 @@ AcpiOsGetTableByName (
     /* Instance is only valid for SSDT/UEFI tables */
 
     if (Instance &&
-        !ACPI_COMPARE_NAME (Signature, ACPI_SIG_SSDT) &&
-        !ACPI_COMPARE_NAME (Signature, ACPI_SIG_UEFI))
+        !ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_SSDT) &&
+        !ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_UEFI))
     {
         return (AE_LIMIT);
     }
@@ -337,7 +337,7 @@ AcpiOsGetTableByName (
      * If one of the main ACPI tables was requested (RSDT/XSDT/FADT),
      * simply return it immediately.
      */
-    if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_XSDT))
+    if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_XSDT))
     {
         if (!Gbl_Revision)
         {
@@ -349,7 +349,7 @@ AcpiOsGetTableByName (
         return (AE_OK);
     }
 
-    if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_RSDT))
+    if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_RSDT))
     {
         if (!Gbl_Rsdp.RsdtPhysicalAddress)
         {
@@ -361,7 +361,7 @@ AcpiOsGetTableByName (
         return (AE_OK);
     }
 
-    if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_FADT))
+    if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_FADT))
     {
         *Address = Gbl_FadtAddress;
         *Table = (ACPI_TABLE_HEADER *) Gbl_Fadt;
@@ -688,15 +688,15 @@ OslGetTableViaRoot (
 
     /* DSDT and FACS address must be extracted from the FADT */
 
-    if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_DSDT) ||
-        ACPI_COMPARE_NAME (Signature, ACPI_SIG_FACS))
+    if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_DSDT) ||
+        ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_FACS))
     {
         /*
          * Get the appropriate address, either 32-bit or 64-bit. Be very
          * careful about the FADT length and validate table addresses.
          * Note: The 64-bit addresses have priority.
          */
-        if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_DSDT))
+        if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_DSDT))
         {
             if ((Gbl_Fadt->Header.Length >= MIN_FADT_FOR_XDSDT) &&
                 Gbl_Fadt->XDsdt)
@@ -759,7 +759,7 @@ OslGetTableViaRoot (
 
             /* Does this table match the requested signature? */
 
-            if (ACPI_COMPARE_NAME (MappedTable->Signature, Signature))
+            if (ACPI_COMPARE_NAMESEG (MappedTable->Signature, Signature))
             {
 
                 /* Match table instance (for SSDT/UEFI tables) */
@@ -862,18 +862,18 @@ OslAddTablesToList(
 
         case 1:
 
-            ACPI_MOVE_NAME (NewInfo->Signature,
+            ACPI_COPY_NAMESEG (NewInfo->Signature,
                 Gbl_Revision ? ACPI_SIG_XSDT : ACPI_SIG_RSDT);
             break;
 
         case 2:
 
-            ACPI_MOVE_NAME (NewInfo->Signature, ACPI_SIG_FACS);
+            ACPI_COPY_NAMESEG (NewInfo->Signature, ACPI_SIG_FACS);
             break;
 
         default:
 
-            ACPI_MOVE_NAME (NewInfo->Signature, ACPI_SIG_DSDT);
+            ACPI_COPY_NAMESEG (NewInfo->Signature, ACPI_SIG_DSDT);
 
         }
 
@@ -919,7 +919,7 @@ OslAddTablesToList(
         while (NewInfo->Next != NULL)
         {
             NewInfo = NewInfo->Next;
-            if (ACPI_COMPARE_NAME (Table->Signature, NewInfo->Signature))
+            if (ACPI_COMPARE_NAMESEG (Table->Signature, NewInfo->Signature))
             {
                 Instance++;
             }
@@ -932,7 +932,7 @@ OslAddTablesToList(
             return (AE_NO_MEMORY);
         }
 
-        ACPI_MOVE_NAME (NewInfo->Signature, Table->Signature);
+        ACPI_COPY_NAMESEG (NewInfo->Signature, Table->Signature);
 
         AcpiOsUnmapMemory (Table, sizeof (*Table));
 
@@ -994,7 +994,7 @@ OslMapTable (
     /* If specified, signature must match */
 
     if (Signature &&
-        !ACPI_COMPARE_NAME (Signature, MappedTable->Signature))
+        !ACPI_COMPARE_NAMESEG (Signature, MappedTable->Signature))
     {
         AcpiOsUnmapMemory (MappedTable, sizeof (*MappedTable));
         return (AE_NOT_EXIST);
diff --git a/sys/contrib/dev/acpica/source/os_specific/service_layers/oslinuxtbl.c b/sys/contrib/dev/acpica/source/os_specific/service_layers/oslinuxtbl.c
index 254a7746d9..d60866dd42 100644
--- a/sys/contrib/dev/acpica/source/os_specific/service_layers/oslinuxtbl.c
+++ b/sys/contrib/dev/acpica/source/os_specific/service_layers/oslinuxtbl.c
@@ -167,7 +167,7 @@ typedef struct osl_table_info
 {
     struct osl_table_info   *Next;
     UINT32                  Instance;
-    char                    Signature[ACPI_NAME_SIZE];
+    char                    Signature[ACPI_NAMESEG_SIZE];
 
 } OSL_TABLE_INFO;
 
@@ -484,7 +484,7 @@ OslAddTableToList (
         return (AE_NO_MEMORY);
     }
 
-    ACPI_MOVE_NAME (NewInfo->Signature, Signature);
+    ACPI_COPY_NAMESEG (NewInfo->Signature, Signature);
 
     if (!Gbl_TableListHead)
     {
@@ -495,7 +495,7 @@ OslAddTableToList (
         Next = Gbl_TableListHead;
         while (1)
         {
-            if (ACPI_COMPARE_NAME (Next->Signature, Signature))
+            if (ACPI_COMPARE_NAMESEG (Next->Signature, Signature))
             {
                 if (Next->Instance == Instance)
                 {
@@ -1050,11 +1050,11 @@ OslGetBiosTable (
 
     /* Handle special tables whose addresses are not in RSDT/XSDT */
 
-    if (ACPI_COMPARE_NAME (Signature, ACPI_RSDP_NAME) ||
-        ACPI_COMPARE_NAME (Signature, ACPI_SIG_RSDT) ||
-        ACPI_COMPARE_NAME (Signature, ACPI_SIG_XSDT) ||
-        ACPI_COMPARE_NAME (Signature, ACPI_SIG_DSDT) ||
-        ACPI_COMPARE_NAME (Signature, ACPI_SIG_FACS))
+    if (ACPI_COMPARE_NAMESEG (Signature, ACPI_RSDP_NAME) ||
+        ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_RSDT) ||
+        ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_XSDT) ||
+        ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_DSDT) ||
+        ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_FACS))
     {
 
 FindNextInstance:
@@ -1066,7 +1066,7 @@ OslGetBiosTable (
          * careful about the FADT length and validate table addresses.
          * Note: The 64-bit addresses have priority.
          */
-        if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_DSDT))
+        if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_DSDT))
         {
             if (CurrentInstance < 2)
             {
@@ -1082,7 +1082,7 @@ OslGetBiosTable (
                 }
             }
         }
-        else if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_FACS))
+        else if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_FACS))
         {
             if (CurrentInstance < 2)
             {
@@ -1098,7 +1098,7 @@ OslGetBiosTable (
                 }
             }
         }
-        else if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_XSDT))
+        else if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_XSDT))
         {
             if (!Gbl_Revision)
             {
@@ -1110,7 +1110,7 @@ OslGetBiosTable (
                     (ACPI_PHYSICAL_ADDRESS) Gbl_Rsdp.XsdtPhysicalAddress;
             }
         }
-        else if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_RSDT))
+        else if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_RSDT))
         {
             if (CurrentInstance == 0)
             {
@@ -1206,7 +1206,7 @@ OslGetBiosTable (
 
             /* Does this table match the requested signature? */
 
-            if (!ACPI_COMPARE_NAME (MappedTable->Signature, Signature))
+            if (!ACPI_COMPARE_NAMESEG (MappedTable->Signature, Signature))
             {
                 OslUnmapTable (MappedTable);
                 MappedTable = NULL;
@@ -1277,7 +1277,7 @@ OslListCustomizedTables (
 {
     void                    *TableDir;
     UINT32                  Instance;
-    char                    TempName[ACPI_NAME_SIZE];
+    char                    TempName[ACPI_NAMESEG_SIZE];
     char                    *Filename;
     ACPI_STATUS             Status = AE_OK;
 
@@ -1377,7 +1377,7 @@ OslMapTable (
                 return (AE_BAD_SIGNATURE);
             }
         }
-        else if (!ACPI_COMPARE_NAME (Signature, MappedTable->Signature))
+        else if (!ACPI_COMPARE_NAMESEG (Signature, MappedTable->Signature))
         {
             AcpiOsUnmapMemory (MappedTable, sizeof (ACPI_TABLE_HEADER));
             return (AE_BAD_SIGNATURE);
@@ -1457,18 +1457,18 @@ OslTableNameFromFile (
 
     /* Ignore meaningless files */
 
-    if (strlen (Filename) < ACPI_NAME_SIZE)
+    if (strlen (Filename) < ACPI_NAMESEG_SIZE)
     {
         return (AE_BAD_SIGNATURE);
     }
 
     /* Extract instance number */
 
-    if (isdigit ((int) Filename[ACPI_NAME_SIZE]))
+    if (isdigit ((int) Filename[ACPI_NAMESEG_SIZE]))
     {
-        sscanf (&Filename[ACPI_NAME_SIZE], "%u", Instance);
+        sscanf (&Filename[ACPI_NAMESEG_SIZE], "%u", Instance);
     }
-    else if (strlen (Filename) != ACPI_NAME_SIZE)
+    else if (strlen (Filename) != ACPI_NAMESEG_SIZE)
     {
         return (AE_BAD_SIGNATURE);
     }
@@ -1479,7 +1479,7 @@ OslTableNameFromFile (
 
     /* Extract signature */
 
-    ACPI_MOVE_NAME (Signature, Filename);
+    ACPI_COPY_NAMESEG (Signature, Filename);
     return (AE_OK);
 }
 
@@ -1549,7 +1549,7 @@ OslReadTableFromFile (
                 goto Exit;
             }
         }
-        else if (!ACPI_COMPARE_NAME (Signature, Header.Signature))
+        else if (!ACPI_COMPARE_NAMESEG (Signature, Header.Signature))
         {
             fprintf (stderr, "Incorrect signature: Expecting %4.4s, found %4.4s\n",
                 Signature, Header.Signature);
@@ -1629,7 +1629,7 @@ OslGetCustomizedTable (
 {
     void                    *TableDir;
     UINT32                  CurrentInstance = 0;
-    char                    TempName[ACPI_NAME_SIZE];
+    char                    TempName[ACPI_NAMESEG_SIZE];
     char                    TableFilename[PATH_MAX];
     char                    *Filename;
     ACPI_STATUS             Status;
@@ -1649,7 +1649,7 @@ OslGetCustomizedTable (
     {
         /* Ignore meaningless files */
 
-        if (!ACPI_COMPARE_NAME (Filename, Signature))
+        if (!ACPI_COMPARE_NAMESEG (Filename, Signature))
         {
             continue;
         }
diff --git a/sys/contrib/dev/acpica/source/os_specific/service_layers/oswintbl.c b/sys/contrib/dev/acpica/source/os_specific/service_layers/oswintbl.c
index a14f719e0f..413c7af382 100644
--- a/sys/contrib/dev/acpica/source/os_specific/service_layers/oswintbl.c
+++ b/sys/contrib/dev/acpica/source/os_specific/service_layers/oswintbl.c
@@ -299,7 +299,8 @@ AcpiOsGetTableByIndex (
     {
         *Instance = Index;
     }
-    else if (Status == AE_NOT_FOUND && ACPI_COMPARE_NAME (Signature, ACPI_SIG_SSDT))
+    else if (Status == AE_NOT_FOUND &&
+        ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_SSDT))
     {
         /* Treat SSDTs that are not found as invalid index. */
         Status = (AE_LIMIT);
@@ -353,7 +354,7 @@ AcpiOsGetTableByName (
 
     /* Multiple instances are only supported for SSDT tables. */
 
-    if (Instance > 0 && !ACPI_COMPARE_NAME (Signature, ACPI_SIG_SSDT))
+    if (Instance > 0 && !ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_SSDT))
     {
         return (AE_LIMIT);
     }
@@ -374,7 +375,7 @@ AcpiOsGetTableByName (
          * OEM ID, Table ID and Revision, then the 29th entry will overwrite the
          * first entry... Let's hope that we do not have that many entries.
          */
-        if (Instance > 0 && ACPI_COMPARE_NAME (Signature, ACPI_SIG_SSDT))
+        if (Instance > 0 && ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_SSDT))
         {
             if (Instance < 10)
             {
@@ -403,15 +404,15 @@ AcpiOsGetTableByName (
              *
              * This code allows for both.
              */
-            if (ACPI_COMPARE_NAME (Signature, "FACP"))
+            if (ACPI_COMPARE_NAMESEG (Signature, "FACP"))
             {
                 Signature = "FADT";
             }
-            else if (ACPI_COMPARE_NAME (Signature, "XSDT"))
+            else if (ACPI_COMPARE_NAMESEG (Signature, "XSDT"))
             {
                 Signature = "RSDT";
             }
-            else if (ACPI_COMPARE_NAME (Signature, ACPI_SIG_SSDT))
+            else if (ACPI_COMPARE_NAMESEG (Signature, ACPI_SIG_SSDT))
             {
                 /* SSDT may not be present on older Windows versions, but it is
                  * also possible that the index is not found. */
diff --git a/sys/contrib/dev/acpica/source/os_specific/service_layers/oswinxf.c b/sys/contrib/dev/acpica/source/os_specific/service_layers/oswinxf.c
index 13849edb9f..138004e36d 100644
--- a/sys/contrib/dev/acpica/source/os_specific/service_layers/oswinxf.c
+++ b/sys/contrib/dev/acpica/source/os_specific/service_layers/oswinxf.c
@@ -173,7 +173,7 @@
 
 
 UINT64                      TimerFrequency;
-char                        TableName[ACPI_NAME_SIZE + 1];
+char                        TableName[ACPI_NAMESEG_SIZE + 1];
 
 #define ACPI_OS_DEBUG_TIMEOUT   30000 /* 30 seconds */
 
diff --git a/sys/contrib/dev/acpica/source/tools/acpidump/apdump.c b/sys/contrib/dev/acpica/source/tools/acpidump/apdump.c
index 2d4177442f..9a2f717668 100644
--- a/sys/contrib/dev/acpica/source/tools/acpidump/apdump.c
+++ b/sys/contrib/dev/acpica/source/tools/acpidump/apdump.c
@@ -475,7 +475,7 @@ int
 ApDumpTableByName (
     char                    *Signature)
 {
-    char                    LocalSignature [ACPI_NAME_SIZE + 1];
+    char                    LocalSignature [ACPI_NAMESEG_SIZE + 1];
     UINT32                  Instance;
     ACPI_TABLE_HEADER       *Table;
     ACPI_PHYSICAL_ADDRESS   Address;
@@ -483,7 +483,7 @@ ApDumpTableByName (
     int                     TableStatus;
 
 
-    if (strlen (Signature) != ACPI_NAME_SIZE)
+    if (strlen (Signature) != ACPI_NAMESEG_SIZE)
     {
         fprintf (stderr,
             "Invalid table signature [%s]: must be exactly 4 characters\n",
@@ -498,11 +498,11 @@ ApDumpTableByName (
 
     /* To be friendly, handle tables whose signatures do not match the name */
 
-    if (ACPI_COMPARE_NAME (LocalSignature, "FADT"))
+    if (ACPI_COMPARE_NAMESEG (LocalSignature, "FADT"))
     {
         strcpy (LocalSignature, ACPI_SIG_FADT);
     }
-    else if (ACPI_COMPARE_NAME (LocalSignature, "MADT"))
+    else if (ACPI_COMPARE_NAMESEG (LocalSignature, "MADT"))
     {
         strcpy (LocalSignature, ACPI_SIG_MADT);
     }
diff --git a/sys/contrib/dev/acpica/source/tools/acpidump/apfiles.c b/sys/contrib/dev/acpica/source/tools/acpidump/apfiles.c
index 0010ca6fbb..784a9315ea 100644
--- a/sys/contrib/dev/acpica/source/tools/acpidump/apfiles.c
+++ b/sys/contrib/dev/acpica/source/tools/acpidump/apfiles.c
@@ -257,7 +257,7 @@ ApWriteToBinaryFile (
     ACPI_TABLE_HEADER       *Table,
     UINT32                  Instance)
 {
-    char                    Filename[ACPI_NAME_SIZE + 16];
+    char                    Filename[ACPI_NAMESEG_SIZE + 16];
     char                    InstanceStr [16];
     ACPI_FILE               File;
     ACPI_SIZE               Actual;
@@ -272,18 +272,18 @@ ApWriteToBinaryFile (
 
     if (ACPI_VALIDATE_RSDP_SIG (Table->Signature))
     {
-        ACPI_MOVE_NAME (Filename, ACPI_RSDP_NAME);
+        ACPI_COPY_NAMESEG (Filename, ACPI_RSDP_NAME);
     }
     else
     {
-        ACPI_MOVE_NAME (Filename, Table->Signature);
+        ACPI_COPY_NAMESEG (Filename, Table->Signature);
     }
 
     Filename[0] = (char) tolower ((int) Filename[0]);
     Filename[1] = (char) tolower ((int) Filename[1]);
     Filename[2] = (char) tolower ((int) Filename[2]);
     Filename[3] = (char) tolower ((int) Filename[3]);
-    Filename[ACPI_NAME_SIZE] = 0;
+    Filename[ACPI_NAMESEG_SIZE] = 0;
 
     /* Handle multiple SSDTs - create different filenames for each */
 
diff --git a/sys/contrib/dev/acpica/source/tools/acpiexec/aecommon.h b/sys/contrib/dev/acpica/source/tools/acpiexec/aecommon.h
index eb24484198..602356de9d 100644
--- a/sys/contrib/dev/acpica/source/tools/acpiexec/aecommon.h
+++ b/sys/contrib/dev/acpica/source/tools/acpiexec/aecommon.h
@@ -287,6 +287,10 @@ void
 AeMiscellaneousTests (
     void);
 
+void
+AeLateTest (
+    void);
+
 /* aeregion */
 
 ACPI_STATUS
diff --git a/sys/contrib/dev/acpica/source/tools/acpiexec/aeexception.c b/sys/contrib/dev/acpica/source/tools/acpiexec/aeexception.c
index 2a25d18130..77ba166bbe 100644
--- a/sys/contrib/dev/acpica/source/tools/acpiexec/aeexception.c
+++ b/sys/contrib/dev/acpica/source/tools/acpiexec/aeexception.c
@@ -206,7 +206,7 @@ AeExceptionHandler (
 
         if (Name)
         {
-            if (ACPI_COMPARE_NAME (&Name, ACPI_ROOT_PATHNAME))
+            if (ACPI_COMPARE_NAMESEG (&Name, ACPI_ROOT_PATHNAME))
             {
                 AcpiOsPrintf (AE_PREFIX
                     "Evaluating executable code at [%s]\n", ACPI_NAMESPACE_ROOT);
diff --git a/sys/contrib/dev/acpica/source/tools/acpiexec/aemain.c b/sys/contrib/dev/acpica/source/tools/acpiexec/aemain.c
index 9ee25805b9..65664b2360 100644
--- a/sys/contrib/dev/acpica/source/tools/acpiexec/aemain.c
+++ b/sys/contrib/dev/acpica/source/tools/acpiexec/aemain.c
@@ -840,6 +840,7 @@ main (
     ExitCode = 0;
 
 ErrorExit:
+    AeLateTest ();
     (void) AcpiTerminate ();
     AcDeleteTableList (ListHead);
     AcpiOsFree (AcpiGbl_InitEntries);
